<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed video_type
 * @property mixed video_url
 * @property mixed images
 */
class CompanyRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('companies'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules =
        [
            'name'=> 'required|min:3|max:30',
            'phone'=> [
                "required",
                "numeric",
                "digits:10",
                Rule::unique('users')->ignore($this->company? $this->company->id : 0, 'id')
            ],
            'email'=> [
                "required",
                "email",
                Rule::unique('users')->ignore($this->company? $this->company->id : 0, 'id')
            ],
            'second_phone'=> [
                "sometimes",
                "nullable",
                "numeric",
                "digits:10",
            ],
            'tax_number'=> [
                "required",
                "numeric",
                "max_digits:10",
                Rule::unique('users')->ignore($this->company? $this->company->id : 0, 'id')
            ],
            'com_number'=> [
                "required",
                "numeric",
                "max_digits:100",
                Rule::unique('users')->ignore($this->company? $this->company->id : 0, 'id')
            ],
            'auth_holder'=>'required|max:50',
            'com_owner'=>'required|max:50',
            'bank_acc'=> [
                "required",
                "numeric",
                "max_digits:20",
                Rule::unique('users')->ignore($this->company? $this->company->id : 0, 'id')
            ],
            'credit_limit'=>'required|numeric|max_digits:11|min:0',
        ];

        if ( !$this->company  ) {
            $rules['password'] ='required|confirmed|min:6';
        } else {
            $rules['password'] ='sometimes|nullable|confirmed|min:6';
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('companies');
        $local = getCurrentLocale();
        $attributes=[
            'image' => __('companies.image'),
            'email' => __('companies.email'),
            'website_url' => __('companies.website_url'),
            'certificate_commercial' => __('companies.certificate_commercial'),
            'tax_certificate' => __('companies.tax_certificate'),
            'company_exhibition' => __('companies.company_exhibition'),
            'company_showroom' => __('companies.company_showroom'),
            'amazon_url' => __('companies.amazon_url'),
            'noon_url' => __('companies.noon_url'),
            'password' => __('companies.password'),

        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => __('companies.name') .' ' . $lang->local,
                'purchasing_'.$lang->local => __('companies.purchasing') .' ' . $lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
